/*
 * InterfaceTP5
 * 
 * Application JAVA qui cree une fenetre de saisie complexe.
 * Cette fenetre permet de remplir des champs et de creer des instances des
 * 3 classes suivantes :
 *                   Batiment
 *                    /   \
 *                Villa   Usine
 * 
 * les zones de saisies sont autorisee/non autorisee en fonction de la saisie
 * courante (maj dynamique de l'interface, avec fenetres de dialogues modales
 */

import java.awt.*;

public class InterfaceTP5 extends Frame {
    private Button instancier, annuler, quitter;            // buttons
    public  Button villa, usine;

    private TextField proprietaire,  adresse, surface;            // One line of text input

    private TextField effectif, nomEntreprise,livraisonQuot; // for "Usine" class
    private CheckboxGroup choisirPiscines; // for "Villa" class
    private Checkbox[] lesPiscines;
    private TextField nbPieces;

    public Panel panelBatiment,panelChoix,panelVilla,panelUsine;   
	 // Sub-containers for all this stuff.
    private Panel panelBoutons; 

    // The layout manager for each of the containers.
    private GridBagLayout gridbag = new GridBagLayout();

    // variables used in instanciation and set by the user interface
    private int valClasse;
    private boolean valPiscine; // true or false
    private String valProprietaire, valAdresse, valNomEntreprise;
    private int valSurface, valNbPieces, valEffectif, valLivraisonQuot;

    // sousClasse = "" si on n'est pas en saisie de sousClasse,
    // sinon = "Usine" ou "Villa"
    public String sousClasse;
        
    public InterfaceTP5(String title) {
        super(title);

        // Create pushbuttons
        instancier = new Button("Instancier");
        annuler = new Button("Annuler");
	quitter = new Button("Quitter");
        
        // Create choix
	usine = new Button("Usine");	
	villa = new Button("Villa");	
        
        // Create a one-line text field, and multi-line text area.
        proprietaire = new TextField(15);
        adresse = new TextField(15);
	surface = new TextField(15);
                
	nomEntreprise = new TextField(15);
	effectif = new TextField(15);
	livraisonQuot = new TextField(15);
	
	choisirPiscines = new CheckboxGroup();
        lesPiscines = new Checkbox[2];
        lesPiscines[0] = new Checkbox("oui", choisirPiscines, false);
        lesPiscines[1] = new Checkbox("non", choisirPiscines, true);
        nbPieces = new TextField(15);
	
        // Create a Panel to contain all the components along the
        // left hand side of the window.  Use a GridBagLayout for it.
        panelBatiment = new Panel();
        panelBatiment.setLayout(gridbag);
        panelBatiment.setBackground(Color.white);
        panelBatiment.setForeground(Color.black);
//	panelBatiment.setFont(new Font("Courier", Font.BOLD, 14));

        // Use several versions of the constrain() convenience method
        // to add components to the panel and to specify their 
        // GridBagConstraints values.
        constrain(panelBatiment, new Label("   Instanciation d'un batiment   "), 0, 0, 1, 1, GridBagConstraints.NONE, GridBagConstraints.CENTER, 0.3, 0.0, 0, 0, 0, 0);
	constrain(panelBatiment, new Label("Nom du proprietaire :"), 0,1,1,1,10,0,0,0);
        constrain(panelBatiment, proprietaire, 0, 2, 1, 1);
        constrain(panelBatiment, new Label("Adresse du batiment :"), 0, 3, 1, 1, 
              10, 0, 0, 0);
	constrain(panelBatiment, adresse, 0,4,1,1);
	constrain(panelBatiment, new Label("Surface (en m2) :"),0,5,1,1,10,0,0,0);
	constrain(panelBatiment, surface, 0,6,1,1);

        panelChoix = new Panel();
        panelChoix.setLayout(gridbag);
//	panelChoix.setFont(new Font("Courier", Font.BOLD, 14));
	constrain(panelChoix, new Label("Ce batiment est plus particulierement un :"),
		0,7,1,1,10,0,0,0);
	constrain(panelChoix, villa, 0,8,1,1);
	constrain(panelChoix, usine, 1,8,1,1);

        panelVilla = new Panel();
	panelVilla.setLayout(gridbag);
        panelVilla.setBackground(Color.white);
//	panelVilla.setFont(new Font("Courier", Font.BOLD, 14));
	constrain(panelVilla, new Label("   Instanciation d'une Villa :   "), 0, 0, 1, 1, GridBagConstraints.NONE, GridBagConstraints.CENTER, 0.3, 0.0, 0, 0, 0, 0);
	constrain(panelVilla, new Label("Nombre de pieces :"),0,1,1,1,10,0,0,0);
	constrain(panelVilla, nbPieces, 0,2,1,1);
	constrain(panelVilla, new Label("Cette villa possede t'elle une piscine ?"),
		0,2,1,1,10,0,0,0);
	constrain(panelVilla, lesPiscines[0], 0,3,1,1);
	constrain(panelVilla, lesPiscines[1], 0,4,1,1);
	panelVilla.disable();
	
	panelUsine =  new Panel();
	panelUsine.setLayout(gridbag);
        panelUsine.setBackground(Color.white);
//	panelUsine.setFont(new Font("Courier", Font.BOLD, 14));
	constrain(panelUsine, new Label("   Instanciation d'une Usine :   "), 0, 0, 1, 1, GridBagConstraints.NONE, GridBagConstraints.CENTER, 0.3, 0.0, 0, 0, 0, 0);
	constrain(panelUsine, new Label("Nom de l'entreprise :"),0,1,1,1,10,0,0,0);
	constrain(panelUsine, nomEntreprise, 0,2,1,1);
	constrain(panelUsine, new Label("Effectif :"),0,3,1,1,10,0,0,0);
	constrain(panelUsine, effectif, 0,4,1,1);
	constrain(panelUsine, new Label("Nombre quotidien moyen de livraison :"),0,5,1,1,10,0,0,0);
	constrain(panelUsine, livraisonQuot, 0,6,1,1);
	panelUsine.disable();

        // Create a panel for the items along the right side.
        // Use a GridBagLayout, and arrange items with constrain(), as above.
        panelBoutons = new Panel();
        panelBoutons.setLayout(gridbag);
//       	panelBoutons.setFont(new Font("Courier", Font.BOLD, 14));	

        constrain(panelBoutons, instancier, 0, 0, 1, 1, GridBagConstraints.NONE,
              GridBagConstraints.CENTER, 0.3, 0.0, 0, 0, 0, 0);
        constrain(panelBoutons, annuler, 1, 0, 1, 1, GridBagConstraints.NONE,
              GridBagConstraints.CENTER, 0.3, 0.0, 0, 0, 0, 0);
        constrain(panelBoutons, quitter, 2, 0, 1, 1, GridBagConstraints.NONE,
              GridBagConstraints.CENTER, 0.3, 0.0, 0, 0, 0, 0);
        
        // Finally, use a GridBagLayout to arrange the panels themselves
        this.setLayout(gridbag);
        // And add the panels to the toplevel window
        constrain(this, panelBatiment, 0, 0, 1, 1, GridBagConstraints.VERTICAL, 
              GridBagConstraints.CENTER, 1.0, 0.0, 5, 0, 0, 0);
        constrain(this, panelChoix, 0, 1, 1, 1, GridBagConstraints.VERTICAL,
              GridBagConstraints.CENTER, 1.0, 0.0, 5, 0, 0, 0);
        constrain(this, panelVilla, 0, 2, 1, 1, GridBagConstraints.VERTICAL,
              GridBagConstraints.CENTER, 1.0, 0.0, 5, 0, 0, 0);
        constrain(this, panelUsine, 1, 2, 1, 1, GridBagConstraints.VERTICAL,
              GridBagConstraints.CENTER, 1.0, 0.0, 5, 0, 0, 0);
        constrain(this, panelBoutons, 0, 3, 1, 1, GridBagConstraints.BOTH,
              GridBagConstraints.CENTER, 1.0, 0.0, 5, 0, 0, 0);

	sousClasse = "";
    }
    
    public void constrain(Container container, Component component, 
                  int grid_x, int grid_y, int grid_width, int grid_height,
                  int fill, int anchor, double weight_x, double weight_y,
                  int top, int left, int bottom, int right)
    {
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = grid_x; c.gridy = grid_y;
        c.gridwidth = grid_width; c.gridheight = grid_height;
        c.fill = fill; c.anchor = anchor;
        c.weightx = weight_x; c.weighty = weight_y;
        if (top+bottom+left+right > 0)
            c.insets = new Insets(top, left, bottom, right);
        
        ((GridBagLayout)container.getLayout()).setConstraints(component, c);
        container.add(component);
    }
    
    public void constrain(Container container, Component component, 
                  int grid_x, int grid_y, int grid_width, int grid_height) {
        constrain(container, component, grid_x, grid_y, 
              grid_width, grid_height, GridBagConstraints.NONE, 
              GridBagConstraints.NORTHWEST, 0.0, 0.0, 0, 0, 0, 0);
    }
    
    public void constrain(Container container, Component component, 
                  int grid_x, int grid_y, int grid_width, int grid_height,
                  int top, int left, int bottom, int right) {
        constrain(container, component, grid_x, grid_y, 
              grid_width, grid_height, GridBagConstraints.NONE, 
              GridBagConstraints.NORTHWEST, 
              0.0, 0.0, top, left, bottom, right);
    }




    // methode de remise a zero
    // - raz des zones de saisies
    // - remettre enable batiment et Choisir et disable Villa et Usine
    // - reinit sousClasse a ""
    public void raz() {
	proprietaire.setText("");
	adresse.setText("");
	surface.setText("");
	lesPiscines[0].setState(false);
	lesPiscines[1].setState(true);
	nbPieces.setText("");
	nomEntreprise.setText("");
	effectif.setText("");
	livraisonQuot.setText("");
	panelBatiment.enable();
	panelChoix.enable();
	panelVilla.disable();
	panelUsine.disable();
	sousClasse = "";
    }

    // This method handles all the events generated by all the components.
    public boolean action(Event event, Object what) {
	
		Batiment batiment = null;
		boolean creerUsine = false;
		
       	// Most components generate ACTION_EVENT
        // We test the target field to find out which component.
	if (event.target == usine) {
		YesNoDialog confirmation = new InstanciationSousClasse(this,"Usine");
		confirmation.show();
	} else if (event.target == villa) {
		YesNoDialog confirmation = new InstanciationSousClasse(this,"Villa");
		confirmation.show();
	} else if (event.target == lesPiscines[0]) {
		valPiscine = true;
	} else if (event.target == lesPiscines[1]) {
		valPiscine = false;
	} else if (event.target == instancier) {
	
	
		// Recuperation des attributs de la classe Batiment communs
		// aux trois classes d'objets
        valProprietaire = proprietaire.getText();
        valAdresse = adresse.getText();
        valSurface = (int) Integer.valueOf(surface.getText()).doubleValue();

		if (sousClasse.equals("")) {
			// on instancie un Batiment
			batiment = new Batiment(valProprietaire, valAdresse, valSurface);
		} else if (sousClasse.equals("Villa")) {
		    // recuperation des attributs specifiques et instanciation
            // d'une Villa
			valNbPieces = (int) Integer.valueOf(nbPieces.getText()).doubleValue();
			batiment = new Villa(valProprietaire, valAdresse, valSurface, valPiscine, valNbPieces);
		} else //if (sousClasse.equals("Usine")) 
		  {
			// recuperation des attributs specifiques et instanciation
            // d'une Usine
			valEffectif = (int) Integer.valueOf(effectif.getText()).doubleValue();
			valNomEntreprise = nomEntreprise.getText();
			valLivraisonQuot = (int) Integer.valueOf(livraisonQuot.getText()).doubleValue();
			batiment = new Usine(valProprietaire, valAdresse, valSurface, valNomEntreprise, valEffectif, valLivraisonQuot);
			creerUsine = true;
			
		}
		
		// affichage des informations associees au batiment instancie
		batiment.affiche();
		System.out.println("Les impots s'elevent a " + batiment.impot());
		if (creerUsine)
		    System.out.println("Mon flot de vehicule quotidien est " + ((Usine) batiment).fluxVehicules());	
		
		
		raz();
		
	} else if (event.target == annuler) {
		this.raz();
	} else if (event.target == quitter) {
		System.exit(0);
	}
	repaint();
	return true;
    }
	
	
   public static void main(String argv[]) {
 	InterfaceTP5 interfaceTP5 = new InterfaceTP5("instancier des classes et leurs heritieres");

	interfaceTP5.resize(890, 700);
	interfaceTP5.pack();        
    interfaceTP5.show();
	
  }

}
